
@use 'sass:map';
@use '@angular/material' as mat;

// Note: Color palettes are generated from primary: #002B6E, secondary: #3860ED
$_palettes: (
  primary: (
    0: #000000,
    10: #001946,
    20: #022c6f,
    25: #15387b,
    30: #244487,
    35: #315093,
    40: #3e5ca0,
    50: #5875bb,
    60: #728fd7,
    70: #8daaf4,
    80: #b1c5ff,
    90: #dae2ff,
    95: #eef0ff,
    98: #faf8ff,
    99: #fefbff,
    100: #ffffff,
  ),
  secondary: (
    0: #000000,
    10: #3860ED,
    20: #002584,
    25: #002e9e,
    30: #0037b9,
    35: #0841d1,
    40: #234fdd,
    50: #446bf8,
    60: #6b89ff,
    70: #92a6ff,
    80: #b8c4ff,
    90: #dde1ff,
    95: #efefff,
    98: #fbf8ff,
    99: #fefbff,
    100: #ffffff,
  ),
  tertiary: (
    0: #000000,
    10: #320046,
    20: #4a1b5d,
    25: #562769,
    30: #623375,
    35: #6f3f82,
    40: #7c4b8f,
    50: #9763a9,
    60: #b27dc5,
    70: #cf97e1,
    80: #ecb2fe,
    90: #f9d8ff,
    95: #feebff,
    98: #fff7fb,
    99: #fffbff,
    100: #ffffff,
  ),
  neutral: (
    0: #000000,
    10: #1a1b20,
    20: #2f3035,
    25: #3a3b40,
    30: #46464c,
    35: #515257,
    40: #5d5e63,
    50: #76777c,
    60: #909096,
    70: #ababb1,
    80: #c6c6cc,
    90: #e3e2e8,
    95: #f1f0f6,
    98: #faf8ff,
    99: #fefbff,
    100: #ffffff,
    4: #0d0e12,
    6: #121318,
    12: #1e1f24,
    17: #292a2f,
    22: #333439,
    24: #38393e,
    87: #dad9e0,
    92: #e8e7ee,
    94: #eeedf4,
    96: #f4f3f9,
  ),
  neutral-variant: (
    0: #000000,
    10: #181b24,
    20: #2d303a,
    25: #383b45,
    30: #444650,
    35: #4f525c,
    40: #5b5e68,
    50: #747782,
    60: #8e909c,
    70: #a9abb6,
    80: #c4c6d2,
    90: #e0e2ee,
    95: #eff0fd,
    98: #faf8ff,
    99: #fefbff,
    100: #ffffff,
  ),
  error: (
    0: #000000,
    10: #410002,
    20: #690005,
    25: #7e0007,
    30: #93000a,
    35: #a80710,
    40: #ba1a1a,
    50: #de3730,
    60: #ff5449,
    70: #ff897d,
    80: #ffb4ab,
    90: #ffdad6,
    95: #ffedea,
    98: #fff8f7,
    99: #fffbff,
    100: #ffffff,
  ),
);

$_rest: (
  secondary: map.get($_palettes, secondary),
  neutral: map.get($_palettes, neutral),
  neutral-variant: map.get($_palettes,  neutral-variant),
  error: map.get($_palettes, error),
);

$primary-palette: map.merge(map.get($_palettes, primary), $_rest);
$tertiary-palette: map.merge(map.get($_palettes, tertiary), $_rest);

@function _high-contrast-value($light, $dark, $theme-type) {
  @if ($theme-type == light) {
    @return $light;
  }
  @if ($theme-type == dark) {
    @return $dark;
  }
  @if ($theme-type == color-scheme) {
    @return light-dark(#{$light}, #{$dark});
  }

  @error 'Unknown theme-type #{$theme-type}. Expected light, dark, or color-scheme';
}

@mixin high-contrast-overrides($theme-type) {
  @include mat.theme-overrides((
    primary: _high-contrast-value(#001844, #edefff, $theme-type),
    on-primary: _high-contrast-value(#ffffff, #000000, $theme-type),
    primary-container: _high-contrast-value(#002b6e, #abc1ff, $theme-type),
    on-primary-container: _high-contrast-value(#e5e9ff, #000925, $theme-type),
    inverse-primary: _high-contrast-value(#b1c5ff, #254588, $theme-type),
    primary-fixed: _high-contrast-value(#274689, #dae2ff, $theme-type),
    primary-fixed-dim: _high-contrast-value(#062f72, #b1c5ff, $theme-type),
    on-primary-fixed: _high-contrast-value(#ffffff, #000000, $theme-type),
    on-primary-fixed-variant: _high-contrast-value(#ffffff, #000f31, $theme-type),
    secondary: _high-contrast-value(#00217a, #eeefff, $theme-type),
    on-secondary: _high-contrast-value(#ffffff, #000000, $theme-type),
    secondary-container: _high-contrast-value(#0039bf, #b2c0ff, $theme-type),
    on-secondary-container: _high-contrast-value(#ffffff, #00072d, $theme-type),
    secondary-fixed: _high-contrast-value(#0039bf, #dde1ff, $theme-type),
    secondary-fixed-dim: _high-contrast-value(#00278a, #b8c4ff, $theme-type),
    on-secondary-fixed: _high-contrast-value(#ffffff, #000000, $theme-type),
    on-secondary-fixed-variant: _high-contrast-value(#ffffff, #000b3b, $theme-type),
    tertiary: _high-contrast-value(#300043, #feeaff, $theme-type),
    on-tertiary: _high-contrast-value(#ffffff, #000000, $theme-type),
    tertiary-container: _high-contrast-value(#48195b, #e8aefa, $theme-type),
    on-tertiary-container: _high-contrast-value(#fbe2ff, #190025, $theme-type),
    tertiary-fixed: _high-contrast-value(#653578, #f9d8ff, $theme-type),
    tertiary-fixed-dim: _high-contrast-value(#4c1d5f, #ecb2fe, $theme-type),
    on-tertiary-fixed: _high-contrast-value(#ffffff, #000000, $theme-type),
    on-tertiary-fixed-variant: _high-contrast-value(#ffffff, #220031, $theme-type),
    background: _high-contrast-value(#faf8ff, #121318, $theme-type),
    on-background: _high-contrast-value(#1a1b20, #e3e2e8, $theme-type),
    surface: _high-contrast-value(#faf8ff, #121318, $theme-type),
    surface-dim: _high-contrast-value(#b9b8be, #121318, $theme-type),
    surface-bright: _high-contrast-value(#faf8ff, #4f5055, $theme-type),
    surface-container-lowest: _high-contrast-value(#ffffff, #000000, $theme-type),
    surface-container: _high-contrast-value(#e3e2e8, #2f3035, $theme-type),
    surface-container-high: _high-contrast-value(#d4d4da, #3a3b40, $theme-type),
    surface-container-highest: _high-contrast-value(#c6c6cc, #46464c, $theme-type),
    on-surface: _high-contrast-value(#000000, #ffffff, $theme-type),
    shadow: _high-contrast-value(#000000, #000000, $theme-type),
    scrim: _high-contrast-value(#000000, #000000, $theme-type),
    surface-tint: _high-contrast-value(#3e5ca0, #b1c5ff, $theme-type),
    inverse-surface: _high-contrast-value(#2f3035, #e3e2e8, $theme-type),
    inverse-on-surface: _high-contrast-value(#ffffff, #000000, $theme-type),
    outline: _high-contrast-value(#292c35, #eeeffc, $theme-type),
    outline-variant: _high-contrast-value(#464953, #c0c2ce, $theme-type),
    error: _high-contrast-value(#600004, #ffece9, $theme-type),
    on-error: _high-contrast-value(#ffffff, #000000, $theme-type),
    error-container: _high-contrast-value(#98000a, #ffaea4, $theme-type),
    on-error-container: _high-contrast-value(#ffffff, #220001, $theme-type),
    surface-variant: _high-contrast-value(#e0e2ee, #444650, $theme-type),
    on-surface-variant: _high-contrast-value(#000000, #ffffff, $theme-type),
  ))
}

:root {
  @include mat.toolbar-overrides((
    container-background-color: #320046,
    container-text-color: white,
  ));

  @include mat.button-overrides((
    filled-container-color: #3860ED,
    filled-label-text-color: white,

  ));
}

html {
  color-scheme: light;
  @include mat.theme((
    color: (
      primary: $primary-palette,
      theme-type: light,
    ),
    typography: "ui-sans-serif, system-ui, sans-serif, 'Apple Color Emoji', 'Segoe UI Emoji', 'Segoe UI Symbol', 'Noto Color Emoji'",
    density: 0
  ));
}
